<?php

require_once _PS_MODULE_DIR_.'Fiserv/classes/FiservTools.php';	    

if (!defined('_PS_VERSION_')) {
    exit;
}

/**
 * Extend logger class to implement logging disable and avoid to check before every log operation.
 */
class FiservFileLogger extends FileLogger {

    private $logs_enabled = false;

    public function __construct($logs_enabled, $level = self::INFO) {
        $this->logs_enabled = $logs_enabled;

        parent::__construct($level);
    }


    public function logInfo($message) {
         parent::logInfo(FiservTools::sanitizeRequest($message));
    }
    


    /**
     * Log message only if logs are enabled.
     *
     * @param string message
     * @param level
     */
    public function log($message, $level = self::DEBUG) {
        if (!$this->logs_enabled) {
            return;
        }
  
        parent::log(FiservTools::sanitizeRequest($message), $level);
    }

}
