<?php

if (!defined('_PS_VERSION_')) {
    exit;
}

/**
 * Generates requests to send to Fiserv.
 */
class FiservUtility {

    public static function getConfig() {
        return array(
            "ind" => array(
                "icici" => array(
                    "plugin_name" => "Fiserv Gateway - ICICI Merchant Services",
                    "reseller_name" => "ICICI Merchant Services",
                    "logo" => 
                    array(
                        array("DESCRIPTION"=>"", "LOGO_PATH" => _MODULE_DIR_ . "Fiserv/views/img/logo/icici.jpg"))                  
                    ,
                    "description" => "Pay securely with",
                    "customer_detail_title" => " ",
                    "customer_detail" => " ",
                    "contact_support_title" => "Contact ICICI Merchant Services Support:",
                    "contact_support" => "Telephone number: 1800 102 1673</br>Email: <a href='mailto:ipghelpdesk@icicims.com'>ipghelpdesk@icicims.com</a> </br>Opening Hours: 24/7",
                    "produrl" => "https://www4.ipg-online.com/connect/gateway/processing",
                    "testurl" => "https://test.ipg-online.com/connect/gateway/processing",
                    "apiurl" => "https://test.ipg-online.com/ipgapi/services",
                    "prodapiurl" => "https://www4.ipg-online.com/ipgapi/services",
                    "local_payment" => array(
                        "RU" => "RuPay",
                        "netbanking" => "Netbanking (India)",
                        "masterpass" => "MasterPass",
                        "indiawallet" => "Local Wallets India"
                    ),
                    "dynamic_merchant_name" => 'yes',
                    "instalments" => 'yes',
                    "secure_pay" => 'yes',
                    "dcc_skip_offer" => 'yes',
                    "refunds" => 'yes',
					"card_type" => 'no',
                ),
                "idfc" => array(
                    "plugin_name" => "IDFC Bank",
                    "reseller_name" => "IDFC",
                    "logo" => 
                    array(
                        array("DESCRIPTION"=>"","LOGO_PATH" =>_MODULE_DIR_ . "Fiserv/views/img/logo/idfc.png")),
                    "description" => "Pay securely with",
                    "customer_detail_title" => " ",
                    "customer_detail" => " ",
                    "contact_support_title" => "Contact IDFC Bank Services Support:",
                    "contact_support" => "Telephone number: 1800 102 1673</br>Email: <a href='mailto:idfcbankpghelpdesk@firstdata.com'>idfcbankpghelpdesk@firstdata.com</a> </br>Opening Hours: 24/7",
                    "produrl" => "https://www4.ipg-online.com/connect/gateway/processing",
                    "testurl" => "https://test.ipg-online.com/connect/gateway/processing",
                    "apiurl" => "https://test.ipg-online.com/ipgapi/services",
                    "prodapiurl" => "https://www4.ipg-online.com/ipgapi/services",
                    "local_payment" => array(
                        "RU" => "RuPay",
                        "netbanking" => "Netbanking (India)",
                        "masterpass" => "MasterPass",
                        "indiawallet" => "Local Wallets India"
                    ),
                    "dynamic_merchant_name" => 'yes',
                    "instalments" => 'yes',
                    "secure_pay" => 'yes',
                    "dcc_skip_offer" => 'yes',
                    "refunds" => 'yes',
                    "card_type" => 'no'
                )
            ),
            "arg" => array(
                    "posnet" => array(
                    "plugin_name" => "Posnet",
                    "reseller_name" => "Posnet",
                    "logo" => array(
                         array("DESCRIPTION"=>"",
                            "LOGO_PATH" => _MODULE_DIR_ . "Fiserv/views/img/logo/posnet-logo.png")),
                    "description" => "Pay securely with",
                    "customer_detail_title" => " ",
                    "customer_detail" => " ",
                    "contact_support_title" => "Para dudas, consultas, revisión de estados de trámites y servicio técnico puede contactarse a través de las siguientes líneas:",
                    "contact_support" => "Capital Federal y GBA: <br>0800-333-4421<br>0800-666-1349<br>Interior del país:<br>0800-666-1422<br>Atención de Lunes a Domingo, las 24 horas.<br><br><a href='http://www.posnet.com.ar'>http://www.posnet.com.ar</a>",
                    "produrl" => "https://www5.ipg-online.com/connect/gateway/processing",
                    "testurl" => "https://test.ipg-online.com/connect/gateway/processing",
                    "apiurl" => "https://test.ipg-online.com/ipgapi/services",
                    "prodapiurl" => "https://www5.ipg-online.com/ipgapi/services",
                    "local_payment" => array(),
                    "dynamic_merchant_name" => 'yes',
                    "instalments" => 'yes',
                    "secure_pay" => 'yes',
                    "dcc_skip_offer" => 'no',
                    "refunds" => 'yes',
					"card_type" => 'no',
            )),
            "col" => array("pagogo" => array(
                    "plugin_name" => "Plataforma Pago Go",
                    "reseller_name" => "Pago Go",
                    "logo" => array( 
                                array("DESCRIPTION"=>"",
                                    "LOGO_PATH" =>_MODULE_DIR_ . "Fiserv/views/img/logo/pagogo.png")),
                    "description" => "Pay securely with",
                    "customer_detail_title" => " ",
                    "customer_detail" => " ",
                    "contact_support_title" => " ",
                    "contact_support" => " ",
                    "produrl" => "https://www2.ipg-online.com/connect/gateway/processing",
                    "testurl" => "https://test.ipg-online.com/connect/gateway/processing",
                    "apiurl" => "https://test.ipg-online.com/ipgapi/services",
                    "prodapiurl" => "https://www2.ipg-online.com/ipgapi/services",
                    "local_payment" => array(),
                    "dynamic_merchant_name" => 'no',
                    "instalments" => 'yes',
                    "secure_pay" => 'no',
                    "dcc_skip_offer" => 'no',
                    "refunds" => 'no',
					"card_type" => 'no',
            )),
            "bra" => array("bin" => array(
                    "plugin_name" => "Plugin FD",
                    "reseller_name" => "Bin",
                    "logo" =>array(
                            array("DESCRIPTION"=>"",
                                "LOGO_PATH" => _MODULE_DIR_ . "Fiserv/views/img/logo/bin.png")),
                    "description" => "Pay securely with",
                    "customer_detail_title" => " ",
                    "customer_detail" => " ",
                    "contact_support_title" => " ",
                    "contact_support" => "3004-2017  para capitais ou </br>0800 757 1017 para as demais regiões  - Horário de atendimento: </br>de segunda às sextas-feiras das 09h às 20h ou pelo </br>e-mail: <a href='mailto:solicitacaoespecial@Fiservcorp.com.br'>solicitacaoespecial@Fiservcorp.com.br</a> ",
                    "produrl" => "https://www2.ipg-online.com/connect/gateway/processing",
                    "testurl" => "https://test.ipg-online.com/connect/gateway/processing",
                    "apiurl" => "https://test.ipg-online.com/ipgapi/services",
                    "prodapiurl" => "https://www2.ipg-online.com/ipgapi/services",
                    "local_payment" => array(
                        "M" => "MasterCard",
                        "V" => "Visa",
						"MA" => "Maestro",
						"CA" => "Cabal",
						"SO" => "Sorocred",
						"hipercard"=> "HIPER/HIPERCARD",
						"EL" => "ELO"),
                    "dynamic_merchant_name" => 'yes',
                    "instalments" => 'yes',
                    "secure_pay" => 'yes',
                    "dcc_skip_offer" => 'no',
                    "refunds" => 'yes',
                    "card_type" => 'yes'
                ),
                "sipag" => array(
                    "plugin_name" => "Plugin FD",
                    "reseller_name" => "SiPag",
                    "logo" => array(
                                array("DESCRIPTION"=>"",
                                    "DEFAULT" 
                                         =>_MODULE_DIR_ . "Fiserv/views/img/logo/sipag.png")
                    ),
                    "description" => "Pay securely with",
                    "customer_detail_title" => " ",
                    "customer_detail" => " ",
                    "contact_support_title" => " ",
                    "contact_support" => "3004-2013  para capitais ou </br>0800 757 1013 para as demais regiões  - Horário de atendimento: </br>de segunda às sextas-feiras das 09h às 20h ou pelo </br>e-mail:  <a href='mailto:solicitacaoespecial@Fiservcorp.com.br'>solicitacaoespecial@Fiservcorp.com.br</a> ",
                    "produrl" => "https://www2.ipg-online.com/connect/gateway/processing",
                    "testurl" => "https://test.ipg-online.com/connect/gateway/processing",
                    "apiurl" => "https://test.ipg-online.com/ipgapi/services",
                    "prodapiurl" => "https://www2.ipg-online.com/ipgapi/services",
                    "local_payment" => array(
                        "M" => "MasterCard",
                        "V" => "Visa",
						"MA" => "Maestro",
						"CA" => "Cabal",
						"SO" => "Sorocred",
						"hipercard"=> "HIPER/HIPERCARD",
						"EL" => "ELO"),
                    "dynamic_merchant_name" => 'yes',
                    "instalments" => 'yes',
                    "secure_pay" => 'yes',
                    "dcc_skip_offer" => 'no',
                    "refunds" => 'yes',
                    "card_type" => 'yes'
                ),
                "sicredi" => array(
                    "plugin_name" => "Plugin FD",
                    "reseller_name" => "Sicredi",
                    "logo" => array(
                                array("DESCRIPTION"=>"",
                                    "LOGO_PATH" =>
                                        _MODULE_DIR_ . "Fiserv/views/img/logo/sicredi.png")
                        ),
                    "description" => "Pay securely with",
                    "customer_detail_title" => " ",
                    "customer_detail" => " ",
                    "contact_support_title" => " ",
                    "contact_support" => "3003-7828  para capitais ou </br>0800 7287828 para as demais regiões  - Horário de atendimento: </br>de segunda às sextas-feiras das 09h às 20h ou pelo </br>e-mail:  <a href='mailto:solicitacaoespecial@Fiservcorp.com.br'>solicitacaoespecial@Fiservcorp.com.br</a> ",
                    "produrl" => "https://www2.ipg-online.com/connect/gateway/processing",
                    "testurl" => "https://test.ipg-online.com/connect/gateway/processing",
                    "apiurl" => "https://test.ipg-online.com/ipgapi/services",
                    "prodapiurl" => "https://www2.ipg-online.com/ipgapi/services",
                    "local_payment" => array(
                        "M" => "MasterCard",
                        "V" => "Visa",
						"MA" => "Maestro",
						"CA" => "Cabal",
						"SO" => "Sorocred",
						"hipercard"=> "HIPER/HIPERCARD",
						"EL" => "ELO"),
                    "dynamic_merchant_name" => 'yes',
                    "instalments" => 'yes',
                    "secure_pay" => 'yes',
                    "dcc_skip_offer" => 'no',
                    "refunds" => 'yes',
                    "card_type" => 'yes'
                )
            ),
            "mex" => array("Fiservmexico" => array(
                    "plugin_name" => "Fiserv Gateway",
                    "reseller_name" => "Fiserv Mexico",
                    "logo" =>array(  
                        
                            array("DESCRIPTION"=>"LBL_PAYMENT_LOGO_WITHOUT_AMEX" ,
                            "LOGO_PATH" =>
                                _MODULE_DIR_ . "Fiserv/views/img/logo/fda.png"),

                           array("DESCRIPTION"=>"LBL_PAYMENT_WITH_LOGO",
                                "LOGO_PATH" =>
                                    _MODULE_DIR_ . "Fiserv/views/img/logo/fda_amex.png")
                    ),
                    "description" => "",
                    "customer_detail_title" => " ",
                    "customer_detail" => " ",
                    "contact_support_title" => "Soporte 24hrs:",
                    "contact_support" => "55 11020660 <a href='mailto:helpdeskmx@firstdata.com'>helpdeskmx@firstdata.com</a>",
                    "produrl" => "https://www2.ipg-online.com/connect/gateway/processing",
                    "testurl" => "https://test.ipg-online.com/connect/gateway/processing",
                    "apiurl" => "https://test.ipg-online.com/ipgapi/services",
                    "prodapiurl" => "https://www2.ipg-online.com/ipgapi/services",
                    "local_payment" => array(
                        "M" => "MasterCard",
                        "V" => "Visa",
						"MA" => "Maestro",
						"A" => "American Express",
						"mexicoLocal" => "MEXICOLOCAL",
						"masterpass" => "Masterpass"
						),
                    "dynamic_merchant_name" => 'no',
                    "instalments" => 'yes',
                    "secure_pay" => 'yes',
                    "dcc_skip_offer" => 'no',
                    "refunds" => 'yes',
                    "card_type" => 'no'
                ),
                "scotiapos" => array(
                    "plugin_name" => "ScotiaPOS",
                    "reseller_name" => "ScotiaPOS",
                    "logo" => array(
                        array("DESCRIPTION"=>"LBL_PAYMENT_LOGO_WITHOUT_AMEX",
                            "LOGO_PATH" =>
                             _MODULE_DIR_ . "Fiserv/views/img/logo/scotiapos.png"),
                        array("DESCRIPTION"=>"LBL_PAYMENT_WITH_LOGO",
                             "LOGO_PATH" =>
                              _MODULE_DIR_ . "Fiserv/views/img/logo/scotiapos_amex.png")
                    ),
                    "description" => "",
                    "customer_detail_title" => " ",
                    "customer_detail" => " ",
                    "contact_support_title" => "Soporte 24hrs:",
                    "contact_support" => "55 11020660 <a href='mailto:helpdeskmx@firstdata.com'>helpdeskmx@firstdata.com</a>",
                    "produrl" => "https://www2.ipg-online.com/connect/gateway/processing",
                    "testurl" => "https://test.ipg-online.com/connect/gateway/processing",
                    "apiurl" => "https://test.ipg-online.com/ipgapi/services",
                    "prodapiurl" => "https://www2.ipg-online.com/ipgapi/services",
                    "local_payment" => array(
                        "M" => "MasterCard",
                        "V" => "Visa",
						"MA" => "Maestro",
						"A" => "American Express",
						"mexicoLocal" => "MEXICOLOCAL",
						"masterpass" => "Masterpass"
						),
                    "dynamic_merchant_name" => 'no',
                    "instalments" => 'yes',
                    "secure_pay" => 'yes',
                    "dcc_skip_offer" => 'no',
                    "refunds" => 'yes',
                    "card_type" => 'no'
                )
            ),
            "gbr" => array("first_data_uk" => array(
                    "plugin_name" => "Fiserv Gateway - UK",
                    "reseller_name" => "Fiserv UK",
                    "logo" => array(
                        array("DESCRIPTION"=>"",
                            "LOGO_PATH" =>
                             _MODULE_DIR_ . "Fiserv/views/img/logo/fdtm.jpg"
                        )
                    ),
                    "description" => "Pay securely with",
                    "customer_detail_title" => " ",
                    "customer_detail" => " ",
                    "contact_support_title" => "Contact Fiserv U.K. Support:",
                    "contact_support" => "Telephone number: +44 (0) 345 606 5055, Option 2</br>Email: <a href='mailto:FDHelpdesk@firstdata.com'>FDHelpdesk@firstdata.com</a></br>Opening Hours: 8am - 9pm, Monday to Saturday (excluding UK Public Holidays)",
                    "produrl" => "https://www.ipg-online.com/connect/gateway/processing",
                    "testurl" => "https://test.ipg-online.com/connect/gateway/processing",
                    "apiurl" => "https://test.ipg-online.com/ipgapi/services",
                    "prodapiurl" => "https://www.ipg-online.com/ipgapi/services",
                    "local_payment" => array(
                        "paypal" => "PayPal",
                        "masterpass" => "MasterPass"
                    ),
                    "dynamic_merchant_name" => 'yes',
                    "instalments" => 'no',
                    "secure_pay" => 'yes',
                    "dcc_skip_offer" => 'yes',
                    "refunds" => 'yes',
                    "card_type" => 'no'
                ),
                "lloyds_cardnet" => array(
                    "plugin_name" => "Lloyds Bank Online Payments",
                    "reseller_name" => "Lloyds Cardnet",
                    "logo" =>array(
                        array("DESCRIPTION"=>"","LOGO_PATH" =>
                             _MODULE_DIR_ . "Fiserv/views/img/logo/lloyds.jpg")
                    ),
                    "description" => "Pay securely with",
                    "customer_detail_title" => " ",
                    "customer_detail" => " ",
                    "contact_support_title" => "Contact Lloyds Cardnet Support:",
                    "contact_support" => "Telephone number: +44 (0) 1268 567 100</br>Opening Hours: 8am - 9pm, Monday to Saturday",
                    "produrl" => "https://www.ipg-online.com/connect/gateway/processing",
                    "testurl" => "https://test.ipg-online.com/connect/gateway/processing",
                    "apiurl" => "https://test.ipg-online.com/ipgapi/services",
                    "prodapiurl" => "https://www.ipg-online.com/ipgapi/services",
                    "local_payment" => array(
                        "paypal" => "PayPal",
                    ),
                    "dynamic_merchant_name" => 'yes',
                    "instalments" => 'no',
                    "secure_pay" => 'yes',
                    "dcc_skip_offer" => 'no',
                    "refunds" => 'yes',
                    "card_type" => 'no'
                )
            ),
            "irl" => array("aib_merchant_services" => array(
                    "plugin_name" => "AIB Merchant Services - Authipay",
                    "reseller_name" => "AIB Merchant Services",
                    "logo" => array(
                                array("DESCRIPTION"=>"", "LOGO_PATH" =>_MODULE_DIR_ . "Fiserv/views/img/logo/aib.png")
                             ),
                    "description" => "Pay securely with",
                    "customer_detail_title" => " ",
                    "customer_detail" => " ",
                    "contact_support_title" => "Contact AIB Merchant Services Support:",
                    "contact_support" => "Telephone number (IRL): 1850 200 417 or +44 1268 567121 (from outside Ireland)</br>Telephone number (GB): 0371 200 1436 or +44 1268 567123 (from outside Ireland)</br>Email: <a href='mailto:authipay@aibms.com'>authipay@aibms.com</a>",
                    "produrl" => "https://www.ipg-online.com/connect/gateway/processing",
                    "testurl" => "https://test.ipg-online.com/connect/gateway/processing",
                    "apiurl" => "https://test.ipg-online.com/ipgapi/services",
                    "prodapiurl" => "https://www.ipg-online.com/ipgapi/services",
                    "local_payment" => array(
                        "paypal" => "PayPal",
                        "masterpass" => "MasterPass",
                        "ideal" => "iDEAL",
                    ),
                    "dynamic_merchant_name" => 'yes',
                    "instalments" => 'no',
                    "secure_pay" => 'yes',
                    "dcc_skip_offer" => 'yes',
                    "refunds" => 'yes',
                    "card_type"=>'no'
                )
            ),
            "nld" => array(
                "european_merchant_services" => array(
                    "plugin_name" => "EMS eCommerce Gateway",
                    "reseller_name" => "European Merchant Services",
                    "logo" => array(
                            array("DESCRIPTION"=>"",  "LOGO_PATH" =>   _MODULE_DIR_ . "Fiserv/views/img/logo/ems.png")
                             ),
                    "description" => "Pay securely with",
                    "customer_detail_title" => "<b>Are you already a customer</b>",
                    "customer_detail" => "If you are already registered as an EMS merchant then please enter the credentials and settings below. </br>For new customers please follow the link below to acquire an EMS merchant account.</br></br><b>Becoming an EMS customer</b></br>Get a merchant account via this link: <a href='https://www.emspay.eu/en/request-an-offer'>https://www.emspay.eu/en/request-an-offer</a>",
                    "contact_support_title" => "Contact EMS Support",
                    "contact_support" => "Visit the FAQ: </br><a href='http://www.emspay.eu/en/customer-service/faq'>http://www.emspay.eu/en/customer-service/faq</a></br></br>Contact information:</br>Telephone number: 0800 711 88</br>Mon-Wed: 08.30-18.00 hrs</br>Thu & Fri: 08.30-19.00 hrs</br>Email: <a href='mailto:contact@be.emspay.eu'>contact@be.emspay.eu</a>",
                    "produrl" => "https://www.ipg-online.com/connect/gateway/processing",
                    "testurl" => "https://test.ipg-online.com/connect/gateway/processing",
                    "apiurl" => "https://test.ipg-online.com/ipgapi/services",
                    "prodapiurl" => "https://www.ipg-online.com/ipgapi/services",
                    "local_payment" => array(
                        "ideal" => "iDEAL",
                        "klarna" => "Klarna",
                        "paypal" => "PayPal",
                        "masterpass" => "MasterPass"
                    ),
                    "dynamic_merchant_name" => 'yes',
                    "instalments" => 'no',
                    "secure_pay" => 'yes',
                    "dcc_skip_offer" => 'no',
                    "refunds" => 'yes',
                    "card_type" => 'no'
                )
            ),
            "deu" => array(
                "first_data_telecash" => array(
                    "plugin_name" => "Fiserv Gateway - TeleCash",
                    "reseller_name" => "Fiserv Telecash",
                    "logo" => array(
                        
                                    array("DESCRIPTION"=>"", "LOGO_PATH" => _MODULE_DIR_ . "Fiserv/views/img/logo/fd-telecash.png")
                            )
                    ,
                    "description" => "Pay securely with",
                    "customer_detail_title" => " ",
                    "customer_detail" => " ",
                    "contact_support_title" => "Contact Fiserv TeleCash Support:",
                    "contact_support" => "Telephone number: +49 (0) 180 6 2255 8844</br>Email: <a href='mailto:internet.support@telecash.de'>internet.support@telecash.de</a>",
                    "produrl" => "https://www.ipg-online.com/connect/gateway/processing",
                    "testurl" => "https://test.ipg-online.com/connect/gateway/processing",
                    "apiurl" => "https://test.ipg-online.com/ipgapi/services",
                    "prodapiurl" => "https://www.ipg-online.com/ipgapi/services",
                    "local_payment" => array(
                        "paypal" => "PayPal",
                        "sofort" => "SOFORT Banking (Überweisung)",
                        "giropay" => "Giropay",
                    ),
                    "dynamic_merchant_name" => 'yes',
                    "instalments" => 'no',
                    "secure_pay" => 'no',
                    "dcc_skip_offer" => 'no',
                    "refunds" => 'yes',
                    "card_type" => 'no'
                )
            ),
            "sgp" => array(
                "first_data_singapore" => array(
                    "plugin_name" => "Fiserv Gateway - Singapore",
                    "reseller_name" => "Fiserv Singapore",
                    "logo" =>array(
                                array("DESCRIPTION"=>"", "LOGO_PATH" =>  _MODULE_DIR_ . "Fiserv/views/img/logo/fda.png")
                             ),
                    "description" => "Pay securely with",
                    "customer_detail_title" => " ",
                    "customer_detail" => " ",
                    "contact_support_title" => "Contact Fiserv Singapore Support:",
                    "contact_support" => "Telephone number: +65 6622 1888</br>Email: <a href='mailto:FDgateway.techsupport@firstdata.com'>FDgateway.techsupport@firstdata.com</a></br>Opening Hours: 24/7",
                    "produrl" => "https://www.ipg-online.com/connect/gateway/processing",
                    "testurl" => "https://test.ipg-online.com/connect/gateway/processing",
                    "apiurl" => "https://test.ipg-online.com/ipgapi/services",
                    "prodapiurl" => "https://www4.ipg-online.com/ipgapi/services",
                    "local_payment" => array(),
                    "dynamic_merchant_name" => 'yes',
                    "instalments" => 'no',
                    "secure_pay" => 'yes',
                    "dcc_skip_offer" => 'yes',
                    "refunds" => 'yes',
					"card_type" => 'no',
            )),
            "hkg" => array("first_data_hong_kong" => array(
                    "plugin_name" => "Fiserv Gateway - Hong Kong",
                    "reseller_name" => "Fiserv Hong Kong",
                    "logo" => array(
                                    array("DESCRIPTION"=>"" ,"LOGO_PATH" =>
                                        _MODULE_DIR_ . "Fiserv/views/img/logo/fda.png")
                        
                        ),
                    "description" => "Pay securely with",
                    "customer_detail_title" => " ",
                    "customer_detail" => " ",
                    "contact_support_title" => "Contact Fiserv Hong Kong Support:",
                    "contact_support" => "Telephone number: +852 3071 5008</br>Email:<a href='mailto:FDgateway.techsupport@firstdata.com'>FDgateway.techsupport@firstdata.com </a></br>Opening Hours: 24/7",
                    "produrl" => "https://www.ipg-online.com/connect/gateway/processing",
                    "testurl" => "https://test.ipg-online.com/connect/gateway/processing",
                    "apiurl" => "https://test.ipg-online.com/ipgapi/services",
                    "prodapiurl" => "https://www4.ipg-online.com/ipgapi/services",
                    "local_payment" => array(),
                    "dynamic_merchant_name" => 'yes',
                    "instalments" => 'no',
                    "secure_pay" => 'yes',
                    "dcc_skip_offer" => 'yes',
                    "refunds" => 'yes',
					"card_type" => 'no',
            )),
            "mys" => array("first_data_malaysia" => array(
                    "plugin_name" => "Fiserv Gateway - Malaysia",
                    "reseller_name" => "Fiserv Malaysia",
                    "logo" => array(
                                    array("DESCRIPTION"=>"" , "LOGO_PATH" =>
                                         _MODULE_DIR_ . "Fiserv/views/img/logo/fda.png")
                                ),
                    "description" => "Pay securely with",
                    "customer_detail_title" => " ",
                    "customer_detail" => " ",
                    "contact_support_title" => "Contact Fiserv Malaysia Support:",
                    "contact_support" => "Telephone number: +60 3 6207 4888</br>Email: <a href='mailto:FDgateway.techsupport@firstdata.com'>FDgateway.techsupport@firstdata.com</a></br>Opening Hours: 24/7",
                    "produrl" => "https://www.ipg-online.com/connect/gateway/processing",
                    "testurl" => "https://test.ipg-online.com/connect/gateway/processing",
                    "apiurl" => "https://test.ipg-online.com/ipgapi/services",
                    "prodapiurl" => "https://www4.ipg-online.com/ipgapi/services",
                    "local_payment" => array(),
                    "dynamic_merchant_name" => 'yes',
                    "instalments" => 'no',
                    "secure_pay" => 'yes',
                    "dcc_skip_offer" => 'yes',
                    "refunds" => 'yes',
                    "card_type" => 'no'
                )
            ),
            "aus" => array(
                "first_data_australia" => array(
                    "plugin_name" => "Fiserv Gateway - Australia",
                    "reseller_name" => "Fiserv Australia",
                    "logo" =>array(
                        
                        array("DESCRIPTION"=>"" , "LOGO_PATH" =>
                                 _MODULE_DIR_ . "Fiserv/views/img/logo/fda.png")
                        ),
                    "description" => "Pay securely with",
                    "customer_detail_title" => " ",
                    "customer_detail" => " ",
                    "contact_support_title" => "Contact Fiserv Austalia Support: ",
                    "contact_support" => "Telephone number: 1800 243 444</br>Email: <a href='mailto:ipgsupport@firstdata.com.au'>ipgsupport@firstdata.com.au</a></br>Opening Hours: 24/7</br>",
                    "produrl" => "https://www.ipg-online.com/connect/gateway/processing",
                    "testurl" => "https://test.ipg-online.com/connect/gateway/processing",
                    "apiurl" => "https://test.ipg-online.com/ipgapi/services",
                    "prodapiurl" => "https://www.ipg-online.com/ipgapi/services",
                    "local_payment" => array(),
                    "dynamic_merchant_name" => 'yes',
                    "instalments" => 'yes',
                    "secure_pay" => 'yes',
                    "dcc_skip_offer" => 'yes',
                    "refunds" => 'yes',
                    "card_type" => 'no'
                )
           ),
            "pan" => array(
                    "banco_general" => array(
                        "plugin_name" => "Fiserv Gateway - Panama",
                        "reseller_name" => "Banco General",
                        "logo" =>array(
                                         array("DESCRIPTION"=>"" , "LOGO_PATH" =>
                                             _MODULE_DIR_ . "Fiserv/views/img/logo/bg.png")
                                ),
                        "description" => "",
                        "customer_detail_title" => " ",
                        "customer_detail" => " ",
                        "contact_support_title" => "Contacto de Soporte de Fiserv Panama: ",
                        "contact_support" => "Email de Soporte: <a href='mailto:elcorreoquequieres@correo.com'>atención-pos@bgeneral.com</a></br>Número de Soporte: 800-5000 opción 4</br>7:00 am a 9:00 pm</br>",
                        "produrl" => "https://www5.ipg-online.com/connect/gateway/processing",
                        "testurl" => "https://test2.ipg-online.com/connect/gateway/processing",
                        "apiurl" => "https://test2.ipg-online.com/ipgapi/services",
                        "prodapiurl" => "https://www5.ipg-online.com/ipgapi/services",
                        "local_payment" => array(),
                        "dynamic_merchant_name" => 'no',
                        "instalments" => 'no',
                        "secure_pay" => 'yes',
                        "dcc_skip_offer" => 'no',
                        "refunds" => 'yes',
                        "card_type" => 'no'
                    )
            ),
            );
    }

    /**
     * Local Payment options supported in IPG configuration
     */
    public static function paymentOptionsValue() {
        return array(
            'M' => 'MasterCard',
            'V' => 'Visa (Credit/Debit/Electron/Delta)',
            'A' => 'American Express',
            'C' => 'Diners',
            'J' => 'JCB',
            'debitDE' => 'SEPA Direct Debit',
            'CA' => 'Cabal',
            'giropay' => 'Giropay',
            'ideal' => 'iDEAL',
            'klarna' => 'Klarna',
            'indiawallet' => 'Local Wallets India',
            'emi' => 'Equated Monthly Instalments (EMI)',
            'MA' => 'Maestro',
            'maestroUK' => 'Maestro UK',
            'masterpass' => 'MasterPass',
            'netbanking' => 'Netbanking (India)',
            'paypal' => 'PayPal',
            'RU' => 'RuPay',
            'sofort' => 'SOFORT Banking (Überweisung)',
            'SO' => 'Sorocred',
            'BCMC' => 'Bancontact',
            'EL' => 'ELO',
            'hipercard'=> 'HIPER/HIPERCARD',            
            "mexicoLocal" => "MEXICOLOCAL"
        );
    }

    public static function getFeatures() {
        $res = FiservUtility::getConfig();
        return json_encode($res);
    }

    public static function getCountryResellerConfig($country, $reseller) {
        $config = FiservUtility::getConfig();
        $result = array();
        if (isset($config[$country][$reseller])) {
            $result = $config[$country][$reseller];
        }

        return $result;
    }

    public static function getLabels() {
        return array(
                    'COUNTRY'=>  array(
                        'es' => 'Country / País',
                        'in' => 'Country / País'
                    ),
                    'RESELLER'=> array(
                        'es' => 'Reseller',
                        'in' => 'Reseller'
                    ),
                    'CONTACT_DETAILS'=>array(
                        'es' => 'Detalles de Contacto',
                        'in' => 'Contact Details'
                    ),
                    'PLUGIN_LOGO'=>array(
                        'es' => 'Logo del Plugin',
                        'in' => 'Plugin Logo'
                    ),
                    'PLUGIN_DESC'=>array(
                        'es' => 'Descripción del Plugin',
                        'in' => 'Plugin Description'
                    ),
                    'SHARED_SECERT'=>array(
                        'es' => 'Shared Secret',
                        'in' => 'Shared Secret'
                    ),
                    'ENV'=>array(
                        'es' => 'Entorno',
                        'in' => 'Environment'
                    ),
                    'STORE_NAME'=>array(
                        'es' => 'Nombre de la tienda',
                        'in' => 'Store Name'
                    ),
                    'STORE_NAME'=>array(
                        'es' => 'Nombre de la tienda',
                        'in' => 'Store Name'
                    ),
                    'SUCCESS_URL'=>array(
                        'es' => 'Url de respuesta exitosa',
                        'in' => 'Response Success URL'
                    ),
                    'FAILURE_URL'=>array(
                        'es' => 'Url de respuesta con error',
                        'in' => 'Response Failure URL'
                    ),
                    'NOTIFICATION_URL'=>array(
                        'es' => 'Url de notificación',
                        'in' => 'Notification URL'
                    ),
                    'AUTHORISATION'=>array(
                        'es' => 'Autorización',
                        'in' => 'Authorisation'
                    ),
                    'CHECKOUT_MODE'=>array(
                        'es' => 'Modo de Compra',
                        'in' => 'Checkout Mode'
                    ),
                    'PAYMENT_MODE'=>array(
                        'es' => 'Modo de Pago',
                        'in' => 'Payment Mode'
                    ),
                    'TOKENISATION'=>array(
                        'es' => 'Tokenisation',
                        'in' => 'Tokenisation'
                    )
                    ,
                    'DYNAMIN_DESC'=>array(
                        'es' => 'Descriptor Dinamico',
                        'in' => 'Dynamic Descriptor'
                    ),
                    'SECURE_PAY'=>array(
                        'es' => '3D Secure',
                        'in' => '3D Secure'
                    ),
                    'DCC_SKIP_OFFER'=>array(
                        'es' => 'Conversión Dinámica de Monedas',
                        'in' => 'Dynamic Currency Conversion'
                    ),
                    'AUTH_METHOD'=>array(
                        'es' => 'Metodo de autorización',
                        'in' => 'Authorisation Method'
                    ),
                    'LOGS'=>array(
                        'es' => 'Logs',
                        'in' => 'Logs'
                    ),
                    'INSTALMENT_ENABLED'=>array(
                        'es' => 'Activación de plazos',
                        'in' => 'Installment Activation'
                    ),
                    'INS_INT_MEXICO'=>array(
                        'es' => 'Interés de plazos para México',
                        'in' => 'Installments Interest For Mexico'
                    ),
                    'PAYMENT_OPTIONS'=>array(
                        'es' => 'Opciones de pago',
                        'in' => 'Payment Options'
                    ),
                    'LOCAL_PAYMENT'=>array(
                        'es' => 'Metodo de pago local',
                        'in' => 'Local Payment Method'
                    ),
                    'ENABLE_DISABLE_LOCAL_PAYMENT'=>array(
                        'es' => 'Activar / Desactivar Método de pago local para checkout',
                        'in' => 'Enable / Disable Local Payment Method for checkout'
                    ),
                    'PAYMENT_METHOD'=>array(
                        'es' => 'Metodos de pago',
                        'in' => 'Payment Method'
                    ),
                    'SETTINGS'=>array(
                        'es' => 'CONFIGURACIÓN',
                        'in' => 'SETTINGS'
                    ),
                    'INSTALMENT_PAYMENT_OPTIONS'=>array(
                        'es' => 'CONFIGURACION DE PAGO EN PLAZOS',
                        'in' => 'INSTALLMENT PAYMENT OPTIONS'
                    ),
                    'LOCAL_PAYMENT_METHOD_OPTIONS'=>array(
                        'es' => 'Opciones de metodos de pago local',
                        'in' => 'Local Payment Method'
                    ),
                    'API_CREDENTIAL'=>array(
                        'es' => 'Credenciales de API',
                        'in' => 'API Credentials'
                    ),
                    'USERNAME'=>array(
                        'es' => 'Nombre de Usuario de API',
                        'in' => 'API Username'
                    ),
                    'PASS'=>array(
                        'es' => 'Contraseña de API',
                        'in' => 'API Password'
                    ),
                    'GENERAL_CONFIGURATION'=>array(
                        'es' => 'CONFIGURACIÓN GENERAL',
                        'in' => 'GENERAL CONFIGURATION'
                    ),
                    'IPG_API_CERTIFICATE_PASSWORD'=>array(
                        'es' => 'Certificado de Password API',
                        'in' => 'API Certificate Password'
                    ),
                    'IPG_API_SERVER_TRUST_PEM'=>array(
                        'es' => 'Archivo de certificado de confianza (Trust PEM)',
                        'in' => 'API Server Trust PEM'
                    )
                    ,'IPG_API_CERTIFICATE_PEM'=>array(
                        'es' => 'Certificado del API .PEM',
                        'in' => 'API Server Trust PEM'
                    ),
                    'IPG_API_CERTIFICATE_KEY'=>array(
                        'es' => 'Llave del certificado del API .KEY',
                        'in' => 'API Certificate Key'
                    ),
                    'PAYMENT_EVENT'=>array(
                        'es' => 'Registrar los eventos de pago en',
                        'in' => 'Log Payment events, inside'
                    ),
                    'ENABLE_DISABLE_INSTALMENT'=>array(
                        'es' => 'Habilitar / deshabilitar interés de las cuotas',
                        'in' => 'Enable / disable installments interest.'
                    ),
                    'API_CREDENTIAL_DESC'=>array(
                        'es' => 'Ingresa tus credenciales de API Fiserv para habilitar el procesamiento mediante API con Fiserv Payment Gateway',
                        'in' => 'Enter your Fiserv API credentials to process different types of API transactions via Fiserv Payment Gateway.'
                    ),
                    'PAYMENT_LOGO'=>array(
                        'es' => 'Modificar Logo',
                        'in' => 'Change Logo'
                    ),
                    'LBL_PAYMENT_LOGO_WITHOUT_AMEX'=>array(
                        'es' => 'No cuentas con afiliación AMEX.',
                        'in' => 'Your account supports AMEX No cuentas con afiliación AMEX.'
                    ),
                    'LBL_PAYMENT_WITH_LOGO'=>array(
                        'es' => 'Tu afiliación soporta AMEX.',
                        'in' => 'Your account supports AMEX.'
                    ),
                    'LBL_CLEAR'=>array(
                        'es' => 'Limpiar',
                        'in' => 'Clear'
                    ),
                    'LBL_DELETE'=>array(
                        'es' => 'Eliminar',
                        'in' => 'Delete'
                    ),
                    'LBL_ADD'=>array(
                        'es' => 'Añadir',
                        'in' => 'Add'
                    ),
                    'LBL_API_CREDENTIALS'=>array(
                        'es' => 'Contact a Fiserv para obtener credenciales para API',
                        'in' => 'Get your API credentials from Fiserv.'
                    ),

                    'LBL_PAYMENT_OPTION_DESC'=>array(
                        'es' => '
                        
                        <p>Haz clic en "Agregar opción de pagos Parciales" para configurar una o mas opciones.<br>
                            <b>Label : </b>La etiqueta para esta opción que se mostrara en tu página.<br>
                            <b>Monto mínimo	 : </b>Monto Mínimo para activar la opción de pago.<br>
                            <b>Monto máximo	 : </b>Monto Máximo para activar esta opción de pago.<br>
                            <b>Pagos : </b>Numero total de pagos.<br>
                            <b class="no_period" style="display: inline;">Periodo : </b><span class="no_period" style="display: inline;">Diferimiento (en días).</span><br>
                            <b>NO olvides hacer clic en "Guardar" para aplicar las modificaciones.</b>
                        </p>
                        
                        ',
                        'in' => '

                        <p>Click on «Add» button to configure one or more payment options.<br>
                            <b>Label : </b>The option label to display on the frontend.<br>
                            <b>Min amount : </b>Minimum amount to enable the payment option.<br>
                            <b>Max amount : </b>Maximum amount to enable the payment option.<br>
                            <b>Count : </b>Total number of payments.<br>
                            <b class="no_period" style="display: inline;">Period : </b><span class="no_period" style="display: inline;">Delay (in days) between payments.</span><br>
                            <b>Do no forget to click on «Save» button to save your modifications.</b>
                        </p>'
                    ),
                    'ENABLED'=>array(
                        'es' => 'Habilitado',
                        'in' => 'Enabled'
                    ),
                    'DISABLED'=>array(
                        'es' => 'Deshabilitado',
                        'in' => 'Disabled'
                    ),
                    'DESHABILITADO'=>array(
                        'es' => 'Deshabilitado',
                        'in' => 'Disabled'
                    ),
                    'HABILITADO'=>array(
                        'es' => 'Habilitado',
                        'in' => 'Enabled'
                    ),
                    'COMBINADO'=>array(
                        'es' => 'Combinado',
                        'in' => 'Combined'
                    ),
                    'COMBINED'=>array(
                        'es' => 'Combinado',
                        'in' => 'Combined'
                    )
                    ,
                    'ACTIVE'=>array(
                        'es' => 'Activo',
                        'in' => 'Active'
                    ),
                    'DEACTIVE'=>array(
                        'es' => 'Desactivado',
                        'in' => 'Deactive'
                    ),
                    'ACTIVO'=>array(
                        'es' => 'Activo',
                        'in' => 'Active'
                    ),
                    'DESACTIVADO'=>array(
                        'es' => 'Desactivado',
                        'in' => 'Deactive'
                    ),
                    'HOSTED_PAYMENT'=>array(
                        'es' => 'Formulario de pago Fiserv',
                        'in' => 'Hosted Payment'
                    ),
                    'FORMULARIO_DE_PAGO_FISERV'=>array(
                        'es' => 'Formulario de pago Fiserv',
                        'in' => 'Hosted Payment'
                    ),
                    'HIDDEN_AUTHORISATION'=>array(
                        'es' => 'Formulario propio',
                        'in' => 'Hidden Authorisation'
                    ),
                    'FORMULARIO_PROPIO'=>array(
                        'es' => 'Formulario propio',
                        'in' => 'Hidden Authorisation'
                    ),
                    'INSTALLMENT_LABEL'=>array(
                        'es' => 'Label',
                        'in' => 'Label'
                    ),
                    'INSTALLMENT_MIN_AMOUNT'=>array(
                        'es' => 'Monto mínimo',
                        'in' => 'Min amount'
                    ),
                    'INSTALLMENT_MAX_AMOUNT'=>array(
                        'es' => 'Monto máximo',
                        'in' => 'Max amount'
                    ),
                    'INSTALLMENT_COUNT'=>array(
                        'es' => 'Pagos',
                        'in' => 'Count'
                    ),
                    'INSTALLMENT_PERIOD'=>array(
                        'es' => 'Periodo',
                        'in' => 'Period'
                    ),
                    'INSTALLMENT_INTEREST'=>array(
                        'es' => 'Interes',
                        'in' => 'Interest'
                    )

            );



    }


}

?>  