<?php

if (!defined('_PS_VERSION_')) {
    exit;
}

/**
 * Class that renders Fiserv payment module administration interface.
 */
class FiservHelperForm {

    private function __construct() {
        // do not instantiate this class
    }

    public static function getAdminFormContext() {
        $context = Context::getContext();

        /* @var Fiserv */
        $Fiserv = Module::getInstanceByName('Fiserv');

        $languages = array();
        foreach (FiservApiHandler::getSupportedLanguages() as $code => $label) {
            $languages[$code] = $Fiserv->l($label, 'Fiservhelperform');
        }
        asort($languages);


        return array(
            'ipg_request_uri' => $_SERVER['REQUEST_URI'],
            'ipg_country_options' => array(
                '' => $Fiserv->l('Select the Country', 'Fiservhelperform'),
                'ind' => $Fiserv->l('India', 'Fiservhelperform'),
                'arg' => $Fiserv->l('Argentina', 'Fiservhelperform'),
                'col' => $Fiserv->l('Colombia', 'Fiservhelperform'),
                'bra' => $Fiserv->l('Brazil', 'Fiservhelperform'),
                'mex' => $Fiserv->l('Mexico', 'Fiservhelperform'),
                'gbr' => $Fiserv->l('United Kingdom', 'Fiservhelperform'),
                'irl' => $Fiserv->l('Ireland', 'Fiservhelperform'),
                'nld' => $Fiserv->l('Netherlands', 'Fiservhelperform'),
                'deu' => $Fiserv->l('Germany', 'Fiservhelperform'),
                'sgp' => $Fiserv->l('Singapore', 'Fiservhelperform'),
                'hkg' => $Fiserv->l('Hong Kong', 'Fiservhelperform'),
                'mys' => $Fiserv->l('Malaysia', 'Fiservhelperform'),
                'aus' => $Fiserv->l('Australia', 'Fiservhelperform'),
                'pan' => $Fiserv->l('Panama', 'Fiservhelperform')
            ),
            'ipg_reseller_options' => array(
                '' => $Fiserv->l('Select the Reseller', 'Fiservhelperform'),
                'icici' => $Fiserv->l('ICICI Merchant Services', 'Fiservhelperform'),
                'idfc' => $Fiserv->l('IDFC', 'Fiservhelperform'),
                'posnet' => $Fiserv->l('Posnet', 'Fiservhelperform'),
                'pagogo' => $Fiserv->l('Pago Go', 'Fiservhelperform'),
                'bin' => $Fiserv->l('Bin', 'Fiservhelperform'),
                'sipag' => $Fiserv->l('SiPag', 'Fiservhelperform'),
                'sicredi' => $Fiserv->l('Sicredi', 'Fiservhelperform'),
                'first_data_mexico' => $Fiserv->l('Fiserv Mexico', 'Fiservhelperform'),
                'scotiapos' => $Fiserv->l('ScotiaPOS', 'Fiservhelperform'),
                'first_data_uk' => $Fiserv->l('Fiserv UK', 'Fiservhelperform'),
                'lloyds_cardnet' => $Fiserv->l('Lloyds Cardnet', 'Fiservhelperform'),
                'aib_merchant_services' => $Fiserv->l('AIB Merchant Services', 'Fiservhelperform'),
                'european_merchant_services' => $Fiserv->l('European Merchant Services', 'Fiservhelperform'),
                'first_data_telecash' => $Fiserv->l('Fiserv Telecash', 'Fiservhelperform'),
                'first_data_singapore' => $Fiserv->l('Fiserv Singapore', 'Fiservhelperform'),
                'first_data_hong_kong' => $Fiserv->l('Fiserv Hong Kong', 'Fiservhelperform'),
                'first_data_malaysia' => $Fiserv->l('Fiserv Malaysia', 'Fiservhelperform'),
                'first_data_australia' => $Fiserv->l('Fiserv Australia', 'Fiservhelperform'),
                'banco_general' => $Fiserv->l('Banco General', 'Fiservhelperform')
            ),
            'ipg_enable_disable_options' => array(
                'no' => $Fiserv->l('Disabled', 'Fiservhelperform'),
                'yes' => $Fiserv->l('Enabled', 'Fiservhelperform')
            ),
            'ipg_ins_enable_disable_options' => array(
                'no' => $Fiserv->l('Disabled', 'Fiservhelperform'),
                'yes' => $Fiserv->l('Enabled', 'Fiservhelperform')
            ),
            'ipg_mode_options' => array(
                'TEST' => $Fiserv->l('TEST', 'Fiservhelperform'),
                'PRODUCTION' => $Fiserv->l('PRODUCTION', 'Fiservhelperform')
            ),
            'ipg_enable_disable_authorisation' => array(
                'yes' => $Fiserv->l('Enabled', 'Fiservhelperform'),
                'no' => $Fiserv->l('Disabled', 'Fiservhelperform')
            ),
            'ipg_checkout_mode_options' => array(
                'classic' => $Fiserv->l('Classic', 'Fiservhelperform'),
                'combinedpage' => $Fiserv->l('Combined', 'Fiservhelperform')
            ),
            'ipg_payment_mode_options' => array(
                'payonly' => $Fiserv->l('Pay Only', 'Fiservhelperform'),
                'payplus' => $Fiserv->l('Pay Plus', 'Fiservhelperform'),
                'fullpay' => $Fiserv->l('Full Pay', 'Fiservhelperform')
            ),
            'ipg_enable_disable_tokenisation' => array(
                'no' => $Fiserv->l('Disabled', 'Fiservhelperform'),
                'yes' => $Fiserv->l('Enabled', 'Fiservhelperform')
            ),
            'ipg_secure_pay_options' => array(
                'active' => $Fiserv->l('Active', 'Fiservhelperform'),
                'deactive' => $Fiserv->l('Deactive', 'Fiservhelperform')
            ),
            'ipg_enable_disable_dcc' => array(
                'no' => $Fiserv->l('Disabled', 'Fiservhelperform'),
                'yes' => $Fiserv->l('Enabled', 'Fiservhelperform')
            ),
            'ipg_auth_method_options' => array(
                'hosted' => $Fiserv->l('Hosted Payment', 'Fiservhelperform'),
                'hidden' => $Fiserv->l('Hidden Authorisation', 'Fiservhelperform')
            ),
            'ipg_multi_enable_disable_options' => array(
                'yes' => $Fiserv->l('Enabled', 'Fiservhelperform'),
                'no' => $Fiserv->l('Disabled', 'Fiservhelperform')
            ),
            'ipg_language_options' => $languages,
            'ipg_default_multi_option' => array(
                'label' => '',
                'min_amount' => '',
                'max_amount' => '',
                'contract' => '',
                'count' => '',
                'period' => '',
                'first' => '',
                'installInt' => '' 
            ),
            'prestashop_categories' => Category::getCategories((int) $context->language->id, true, false),
            'prestashop_languages' => Language::getLanguages(false),
            'prestashop_lang' => Language::getLanguage((int) $context->language->id),
            'prestashop_carriers' => Carrier::getCarriers(
                    (int) $context->language->id, true, false, false, null, Carrier::ALL_CARRIERS
            ),


            'prestashop_groups' => self::getAuthorizedGroups(),
            'LOGS' => Configuration::get('LOGS'),
            'COUNTRY' => Configuration::get('COUNTRY'),
            'RESELLER' => Configuration::get('RESELLER'),
            'PLUGIN_NAME' => Configuration::get('PLUGIN_NAME'),
            'PLUGIN_DESC' => Configuration::get('PLUGIN_DESC'),
            'PLUGIN_LOGO' => Configuration::get('PLUGIN_LOGO'),
            'LOGO_DISPLAY' => Configuration::get('LOGO_DISPLAY'),
            'CUSTOMER_DETAIL_TITLE' => Configuration::get('CUSTOMER_DETAIL_TITLE'),
            'CUSTOMER_DETAIL' => Configuration::get('CUSTOMER_DETAIL'),
            'CONTACT_SUPPORT_TITLE' => Configuration::get('CONTACT_SUPPORT_TITLE'),
            'CONTACT_SUPPORT' => Configuration::get('CONTACT_SUPPORT'),
            'ENV' => Configuration::get('ENV'),
            'TEST_SHARED_SECERT' => Configuration::get('TEST_SHARED_SECERT'),
            'TEST_STORE_NAME' => Configuration::get('TEST_STORE_NAME'),
            'TEST_SUCCESS_URL' => Configuration::get('TEST_SUCCESS_URL'),
            'TEST_FAILURE_URL' => Configuration::get('TEST_FAILURE_URL'),
            'TEST_NOTIFICATION_URL' => Configuration::get('TEST_NOTIFICATION_URL'),
            'PROD_SHARED_SECERT' => Configuration::get('PROD_SHARED_SECERT'),
            'PROD_STORE_NAME' => Configuration::get('PROD_STORE_NAME'),
            'PROD_SUCCESS_URL' => Configuration::get('PROD_SUCCESS_URL'),
            'PROD_FAILURE_URL' => Configuration::get('PROD_FAILURE_URL'),
            'PROD_NOTIFICATION_URL' => Configuration::get('PROD_NOTIFICATION_URL'),
            'AUTHORISATION' => Configuration::get('AUTHORISATION'),
            'CHECKOUT_MODE' => Configuration::get('CHECKOUT_MODE'),
            'PAYMENT_MODE' => Configuration::get('PAYMENT_MODE'),
            'TOKENISATION' => Configuration::get('TOKENISATION'),
            'DYNAMIN_DESC' => Configuration::get('DYNAMIN_DESC'),
            'SECURE_PAY' => Configuration::get('SECURE_PAY'),
            'DCC_SKIP_OFFER' => Configuration::get('DCC_SKIP_OFFER'),
            'AUTH_METHOD' => Configuration::get('AUTH_METHOD'),
            'INSTALMENT_ENABLED' => Configuration::get('INSTALMENT_ENABLED'),
            'INS_INT_MEXICO' => Configuration::get('INS_INT_MEXICO'),
            'LOCAL_PAYMENT' => Configuration::get('LOCAL_PAYMENT'),
            'PAYMENT_METHOD' => self::getArrayConfig('PAYMENT_METHOD'),
            'INS_MULTI_OPTIONS' => self::getArrayConfig('INS_MULTI_OPTIONS'),
            'IPG_API_USERNAME' => Configuration::get('IPG_API_USERNAME'),
            'IPG_API_PASSWORD' => Configuration::get('IPG_API_PASSWORD'),
            'IPG_API_CERTIFICATE_PASSWORD' => Configuration::get('IPG_API_CERTIFICATE_PASSWORD'),
            'IPG_API_SERVER_TRUST_PEM' => Configuration::get('IPG_API_SERVER_TRUST_PEM'),
            'IPG_API_CERTIFICATE_PEM' => Configuration::get('IPG_API_CERTIFICATE_PEM'),
            'IPG_API_CERTIFICATE_KEY' => Configuration::get('IPG_API_CERTIFICATE_KEY'),
            'IPG_API_URL' => Configuration::get('IPG_API_URL')
        );


    }

    private static function getIpnUrl($rest = false) {
        $shop = new Shop(Configuration::get('PS_SHOP_DEFAULT'));

        // ssl enabled on default shop ?
        $id_shop_group = isset($shop->id_shop_group) ? $shop->id_shop_group : $shop->id_group_shop;
        $ssl = Configuration::get('PS_SSL_ENABLED', null, $id_shop_group, $shop->id);

        $ipn = ($ssl ? 'https://' . $shop->domain_ssl : 'http://' . $shop->domain)
                . $shop->getBaseURI() . 'modules/Fiserv/validation' . ($rest ? '_rest' : '') . '.php';

        return $ipn;
    }

    private static function getArrayConfig($name) {

        $value = @unserialize(Configuration::get($name));

        if (!is_array($value)) {
            $value = array();
        }
        return $value;
    }

    private static function getLangConfig($name) {
        $languages = Language::getLanguages(false);

        $result = array();
        foreach ($languages as $language) {
            $result[$language['id_lang']] = Configuration::get($name, $language['id_lang']);
        }

        return $result;
    }

    private static function getAuthorizedGroups() {
        $context = Context::getContext();

        /* @var Fiserv */
        $Fiserv = Module::getInstanceByName('Fiserv');

        $sql = 'SELECT DISTINCT gl.`id_group`, gl.`name` FROM `' . _DB_PREFIX_ . 'group_lang` AS gl
            INNER JOIN `' . _DB_PREFIX_ . 'module_group` AS mg
            ON (
                gl.`id_group` = mg.`id_group`
                AND mg.`id_module` = ' . (int) $Fiserv->id . '
                AND mg.`id_shop` = ' . (int) $context->shop->id . '
            )
            WHERE gl.`id_lang` = ' . (int) $context->language->id;

        return Db::getInstance()->executeS($sql);
    }

}
