<?php 
global $smarty;  
require_once _PS_MODULE_DIR_.'Fiserv/classes/FiservFileLogger.php';
require_once _PS_MODULE_DIR_.'Fiserv/classes/FiservTools.php';	

class FiservFailureModuleFrontController extends ModuleFrontController
{

    public function postProcess() {
        $response = FiservTools::sanitizeRequest($_REQUEST);

        $cart = $this->context->cart;
        if ($cart->id_customer == 0 || $cart->id_address_delivery == 0 || $cart->id_address_invoice == 0 || !$this->module->active) {
            Tools::redirect('index.php?controller=order&step=1');
        }

        // Check that this payment option is still available in case the customer changed his address just before the end of the checkout process
        $authorized = false;
        foreach (Module::getPaymentModules() as $module) {
            if ($module['name'] == 'Fiserv') {
                $authorized = true;
                break;
            }
        }

        if (!$authorized) {
            die($this->module->l('This payment method is not available.', 'validation'));
        }


        $this->context->smarty->assign([
            'params' => $response,
        ]);


        $Fiserv = new Fiserv();
        

        global $kernel;
        if(!$kernel){ 
            require_once _PS_ROOT_DIR_.'/app/AppKernel.php';
            $kernel = new \AppKernel('prod', false);
            $kernel->boot(); 
        }
       


        $baseUrl=Tools::getShopDomain(true, true).__PS_BASE_URI__;		
        $cart_id=  isset($response['oid'])?$response['oid']:0;	
        $transactionId= isset($response['ipgTransactionId'])?$response['ipgTransactionId']:0;
        $paymentType= isset($response['txntype'])?$response['txntype']:"";
        $chargetotal = isset($response['chargetotal'])?$response['chargetotal']:"";
        
        $responseValue= print_r($response,true);
        FiservTools::getLogger()->logInfo('Response failure ' . $responseValue);

        $cart = new Cart((int)$cart_id);

        $this->context->smarty->assign('baseUrl','index.php');
        $this->context->smarty->assign('isValidationFailed', false);
        $this->context->smarty->assign('transactionId',$transactionId);

        $customer = new Customer((int)$cart->id_customer);
        $customer_id = $customer->id;

        $currency = new CurrencyCore($cart->id_currency);
        $currencyCode = $currency->iso_code;

        $validateGatewayHash = $Fiserv->validateGatewayHash($response, false);
        
        if ($validateGatewayHash === true) {            
            $approval_code = substr($response['approval_code'], 0, 1);
            if ($approval_code == 'N')
            {			
                if ($cart->OrderExists() == false) {									
                    $orderCreated = $Fiserv->validateOrder((int)$cart->id, Configuration::get('PS_OS_ERROR'), $chargetotal, $Fiserv->displayName, NULL, NULL, (int)$currency->id, false, $customer->secure_key);  		
                    if(!$orderCreated){
                        $this->context->smarty->assign('isValidationFailed', true);
                    }
                }
                $result = Db::getInstance()->getRow('SELECT * FROM ' . _DB_PREFIX_ . 'orders WHERE id_cart = ' . (int)$cart->id);                    
                $this->context->smarty->assign('orderId', $result['id_order']);
            }
        }else{
            FiservTools::getLogger()->logInfo('Invalid Response Hash received for Order ID: ' . $transactionId);
            $this->context->smarty->assign('isValidationFailed', true);
        }
        
        $this->context->customer->logged = true;
        $this->context->cart = new Cart();
        $this->setTemplate('module:Fiserv/views/templates/front/failure.tpl');

    }
  
    
}



?>
