<?php 
ini_set('display_errors', 1);
ini_set('display_startup_errors', 1);
error_reporting(E_ALL); 
/**
* Instant payment notification file. Wait for Fiserv payment confirmation, then validate order.
*/



require_once _PS_MODULE_DIR_.'Fiserv/classes/FiservFileLogger.php';
require_once _PS_MODULE_DIR_.'Fiserv/classes/FiservTools.php';	    

class FiservNotifyModuleFrontController extends ModuleFrontController
{

    public function postProcess()
    {

       
        $cart = $this->context->cart;
        $response =  FiservTools::sanitizeRequest($_REQUEST);
      
        if ($cart->id_customer == 0 || $cart->id_address_delivery == 0 || $cart->id_address_invoice == 0 || !$this->module->active) {
           // Tools::redirect('index.php?controller=order&step=1');
        }

        // Check that this payment option is still available in case the customer changed his address just before the end of the checkout process
        $authorized = false;
        foreach (Module::getPaymentModules() as $module) {
            if ($module['name'] == 'Fiserv') {
                $authorized = true;
                break;
            }
        }

        if (!$authorized) {
            die($this->module->l('This payment method is not available.', 'notify'));
        }

        $this->context->smarty->assign([
            'params' => $response,
        ]);


        $Fiserv = new Fiserv();
        
        // Logging
        $responseValue= print_r($response,true);
        FiservTools::getLogger()->logInfo($responseValue);
        
        $cart_id = isset($response['oid'])?$response['oid']:0;

        $transactionId = '';
        if (isset( $response['ipgTransactionId']))
        $transactionId = $response['ipgTransactionId'];
        
        
        $paymentType =  isset($response['txntype'])?$response['txntype']:"";

        $cart = new Cart((int)$cart_id);
        
        $total = (float)($cart->getOrderTotal(true, Cart::BOTH));

        $customer = new Customer((int)$cart->id_customer);
        $customer_id = $customer->id;

        $currency = new CurrencyCore($cart->id_currency);
        $currencyCode = $currency->iso_code;

        $validateGatewayHash = $Fiserv->validateGatewayHash($response, true);

        if ($validateGatewayHash === false) {
            FiservTools::getLogger()->logInfo('Invalid Response Hash received for Order ID: ' . $transactionId);
            die('Invalid Response Hash received for Order ID: ' . $transactionId);		
        }	
        if (isset( $response['approval_code']))
            $approval_code = substr($response['approval_code'], 0, 1);


        
        if($approval_code == 'Y')
        {		                
            $orderCreated = $Fiserv->validateOrder((int)$cart->id, Configuration::get('PS_OS_PAYMENT'), $total, $Fiserv->displayName, NULL, NULL, (int)$currency->id, false, $customer->secure_key);    		
            if($orderCreated){
                /* Tokenization Handle Start */
                if(isset($response['hosteddataid']) && $response['hosteddataid'] != '') {
                        $custId = $customer_id;
                        $tokenId = $response['hosteddataid'];
                        $pseudo_cc_no = $response['ccbin'];
                        $pseudo_cc_no = preg_replace("/^\([A-Z]+\)/", $response['ccbin'], $response['cardnumber']);
                        $brand = $response['ccbrand'];
                        $resCard = Db::getInstance()->getRow("SELECT * FROM ps_saved_cards WHERE customer_id = '$custId' and pseudo_cc_no = '$pseudo_cc_no' and brand = '$brand'");
                        if ($resCard['saved_card_id'] == '') {
                                $sql = "INSERT IGNORE INTO ps_saved_cards (customer_id, token_id, pseudo_cc_no, brand) VALUES ($custId, '$tokenId', '$pseudo_cc_no', '$brand')";
                                $insRes  = Db::getInstance()->execute($sql);
                        }
                }
                /* Tokenization Handle End */		
                if (isset($response['number_of_installments']) && $response['number_of_installments'] != '') {
                        $EMImsg = 'Transaction success with '.$response['number_of_installments'].' configured';
                        FiservTools::addOrderNoteForEMI($cart_id, $EMImsg);
                }

                $paymentStatus = $response['status'];
                if ($transactionId != '') {
                        $responseSql = "INSERT INTO ps_firstdata_order (id_cart, id_transaction, payment_status, payment_type, currency_code) VALUES ($cart_id,'$transactionId', '$paymentStatus', '$paymentType','$currencyCode');";
                        $insFdRes  = Db::getInstance()->execute($responseSql);
                }
            }
        } else {



            $Fiserv->validateOrder((int)$cart->id, Configuration::get('PS_OS_ERROR'), $total, $Fiserv->displayName, NULL, NULL, (int)$currency->id, false, $customer->secure_key);  		
        }
    }
    
}

?>