<?php

/**
 * This controller prepares form and redirects to Fiserv payment gateway.
 */
global $smarty;  

class FiservPaymentModuleFrontController extends ModuleFrontController {

    public function initContent() {
        global $cookie;
        $cart = $this->context->cart;
        $currency = new Currency($cart->id_currency);
        $currencyCode = $currency->iso_code_num;
      
        // Prepare payment
        $customer = new Customer((int) $cart->id_customer);
        if (!Validate::isLoadedObject($customer))
            Tools::redirectLink(__PS_BASE_URI__ . 'order.php?step=1');

        $total = (float) ($cart->getOrderTotal(true, Cart::BOTH));

        /*total price*/
         $total_price =  $this->context->cart->getSummaryDetails()["total_price"];

         /*tax*/ 
        $total_taxes =  $this->context->cart->getSummaryDetails()["total_tax"];

        /*total price with out tax*/
        $total_price_without_tax = $this->context->cart->getSummaryDetails()["total_price_without_tax"];
        
    
        /*shiping price*/ 
        $total_shipping =  $this->context->cart->getSummaryDetails()["total_shipping"];

        /*total with out shiping*/
        $subtotal =  $this->context->cart->getSummaryDetails()["total_products_wt"];

     
        $customer = new Customer((int) ($cart->id_customer));
        $amount =  $total_price;

        $baseUrl = Tools::getShopDomain(true, true) . __PS_BASE_URI__;
        $successUrl = $baseUrl . 'index.php?fc=module&module=Fiserv&controller=success';
        $failedUrl = $baseUrl . 'index.php?fc=module&module=Fiserv&controller=failure';
        $notifyUrl = $baseUrl . 'index.php?fc=module&module=Fiserv&controller=notify';

        $enviornment = Configuration::get('ENV');
        $country = Configuration::get('COUNTRY');
        $reseller = Configuration::get('RESELLER');
      
        $local_payment = Configuration::get('LOCAL_PAYMENT');
        $enable_installment = Configuration::get('INSTALMENT_ENABLED');

     


        $paymentMode = Configuration::get('PAYMENT_MODE');
        $txtType = Configuration::get('AUTHORISATION');
        $checkoutMode = Configuration::get('CHECKOUT_MODE');
        $dynamicDesc = Configuration::get('DYNAMIN_DESC');
        $securePay = Configuration::get('SECURE_PAY');
        $dcc = Configuration::get('DCC_SKIP_OFFER');
        $authUX = Configuration::get('AUTH_METHOD');
        $enable_tokenization = Configuration::get('TOKENISATION');

        $cr_config = FiservUtility::getCountryResellerConfig($country, $reseller);
        if ($enviornment == 'TEST') {
            $connectURL = $cr_config['testurl']; //Testing Url
            $url = Configuration::get('TEST_STORE_NAME');
            $storename = Configuration::get('TEST_STORE_NAME');
            $sharedSecret = Configuration::get('TEST_SHARED_SECERT');
            $customNotifyUrl = Configuration::get('TEST_NOTIFICATION_URL');
            $customSuccessUrl = Configuration::get('TEST_SUCCESS_URL');
            $customFailedUrl = Configuration::get('TEST_FAILURE_URL');
        } else {
            $connectURL = $cr_config['produrl'];
            $url = Configuration::get('PROD_STORE_NAME');
            $storename = Configuration::get('PROD_STORE_NAME');
            $sharedSecret = Configuration::get('PROD_SHARED_SECERT');
            $customNotifyUrl = Configuration::get('PROD_NOTIFICATION_URL');
            $customSuccessUrl = Configuration::get('PROD_SUCCESS_URL');
            $customFailedUrl = Configuration::get('PROD_FAILURE_URL');
        }
        $notifyUrl = $customNotifyUrl != '' ? $customNotifyUrl : $notifyUrl;
        $successUrl = $customSuccessUrl != '' ? $customSuccessUrl : $successUrl;
        $failedUrl = $customFailedUrl != '' ? $customFailedUrl : $failedUrl;

        $timezone = "IST";
        date_default_timezone_set('Asia/Kolkata');
        $txndatetime = date('Y:m:d-H:i:s');
        $iso_code = Language::getIsoById((int) $cookie->id_lang);
		$langArr = array('en' => 'en_EN', 'es' => 'es_ES', 'mx' => 'es_ES','br' => 'pt_BR',);
        $langCode = $langArr[$iso_code];
        $language = $langCode;
	  

        $orderId = (int) $cart->id;
      
        $enable = false;
        $errors = array();
        if ($authUX == 'hidden') {
            $saved_token = htmlspecialchars($_REQUEST['pay_type'], ENT_QUOTES, 'UTF-8');
            if ($saved_token == 'newcard') {
                $inpCCArr = array('card_number' => htmlspecialchars($_REQUEST['Fiserv_card_number'], ENT_QUOTES, 'UTF-8'), 'cvv' => htmlspecialchars($_REQUEST['Fiserv_cvv'], ENT_QUOTES, 'UTF-8'), 'expiry_month' => htmlspecialchars($_REQUEST['Fiserv_expiry_month'], ENT_QUOTES, 'UTF-8'), 'expiry_year' => htmlspecialchars($_REQUEST['Fiserv_expiry_year'], ENT_QUOTES, 'UTF-8'));
                $errors = FiservTools::checkCreditCard($inpCCArr);
            } else {
                $errors = array();
                $enable = true;
            }
        } else {
            $errors = array();
        }
     

      //  $smarty->assign('fd_error_msg','errors');
        if (count($errors) > 0) {
            $this->context->cookie->FiservPayErrors = implode("\n", $errors);
           // Tools::redirectLink(__PS_BASE_URI__ . 'order.php?step=3');

            $this->errors =  $errors;
          //  $this->redirectWithNotifications($this->getCurrentURL());

            $this->context->controller->redirectWithNotifications(
                __PS_BASE_URI__ . 'order.php?step=3'
            );

         
        } else {
            unset($this->context->cookie->FiservPayErrors);
        }


        $ipg_args = array(
            'timezone' => $timezone,
            'txndatetime' => $txndatetime,
            'hash' => $this->createHash($txndatetime, $amount, $currencyCode, $storename, $sharedSecret),
            'currency' => $currencyCode,
            'mode' => $paymentMode,
            'storename' => $storename,
            'chargetotal' => $amount,
            'language' => $language,
            'responseSuccessURL' => $successUrl,
            'responseFailURL' => $failedUrl,
            'transactionNotificationURL' => $notifyUrl,
            'txntype' => $txtType == 'yes' ? 'sale' : 'preauth',
            'checkoutoption' => $checkoutMode,
            'dynamicMerchantName' => $dynamicDesc,
            'authenticateTransaction' => $securePay == 'active' ? 'true' : 'false',
            'dccSkipOffer' => $dcc == 'yes' ? 'false' : 'true',
            'oid' => $orderId,
        );

        $address = new Address(intval($cart->id_address_delivery), intval($cookie->id_lang));
        //$country = new Address(intval($address->id_country));

        $ipg_args['bname'] = $address->firstname . ' ' . $address->lastname;
        $ipg_args['bcompany'] = $address->company;
        $ipg_args['baddr1'] = $address->address1;
        $ipg_args['baddr2'] = $address->address2;
        $ipg_args['bcity'] = $address->city;
        $state = State::getNameById($address->id_state);
        $ipg_args['bstate'] = $state;

        $ipg_args['bcountry'] = $address->id_country;
        $ipg_args['bzip'] = $address->postcode;
        $ipg_args['phone'] = $address->phone_mobile;
        if ($ipg_args['phone'] == '')
            $ipg_args['phone'] = $address->phone;

        $ipg_args['email'] = $customer->email;
        $ipg_args['fax'] = '';
        $ipg_args['sname'] = $address->firstname . ' ' . $address->lastname;
        $ipg_args['saddr1'] = $address->address1;
        $ipg_args['saddr2'] = $address->address2;
        $ipg_args['scity'] = $address->city;
        $ipg_args['sstate'] = $state;
        $ipg_args['scountry'] = $address->id_country;
        $ipg_args['szip'] = $address->postcode;


        /*
         * Handle Tokenization if it enabled
         */
        $pay_type = isset($_REQUEST['pay_type'])? htmlspecialchars($_REQUEST['pay_type']) : '';
        if ($enable_tokenization == 'yes') {
            if ($pay_type == 'savedcard' && isset($_REQUEST['saved_cards_opt'])) {
                $token = htmlspecialchars($_REQUEST['saved_cards_opt'], ENT_QUOTES, 'UTF-8');
                if ($token != 'new' && !empty($token)) {
                    if ($token) {
                        $ipg_args['hosteddataid'] = $token;
                        $ipg_args['hosteddatastoreid'] = $storename;
                    }
                }
            } else {

                $ipg_args['assignToken'] = 'true';
            }
        }

        /*
         * Add local/alternative payment method
         */


        if ($local_payment == 'yes') {
            $payMethod = htmlspecialchars($_REQUEST['locPayCard'], ENT_QUOTES, 'UTF-8');
            $checkLocPay = htmlspecialchars($_REQUEST['check_loc_pay'], ENT_QUOTES, 'UTF-8');

            if ($payMethod == '' && $checkLocPay == 1) {
                $errors = FiservTools::checkLocalPayment($payMethod);
            } else {
                $errors = array();
            }
            if (count($errors) > 0) {
                $this->context->cookie->FiservPayErrors = implode("\n", $errors);
                Tools::redirectLink(__PS_BASE_URI__ . 'order.php?step=3');
            } else {
                unset($this->context->cookie->FiservPayErrors);
            }
            if ($payMethod != '' && $this->validpaymentOptions($payMethod) == false) {
                FiservTools::getLogger()->logInfo('Received invalid value ' . $payMethod . ' Local Payment option from checkout');
            } else if ($payMethod != '' && $this->validpaymentOptions($payMethod) == true) {
                FiservTools::getLogger()->logInfo('Received Local Payment option from checkout', 'info');
                $ipg_args['paymentMethod'] = $payMethod;

                /**
                 * Added for ICICI and IDFC bank in india for local payment method netbanking support 
                 */
                if ('ind' == $country && 'netbanking' == $payMethod) {
                    $ipg_args['semail'] = $customer->email;
                }
            }
        }
     

        /*
         * Handle installment if it enabled and user selected the installment in checkout
         */
        

 
        if ($enable_installment == "yes"){
            $payment_type = htmlspecialchars($_REQUEST['payment_type'], ENT_QUOTES, 'UTF-8');
            $ins_payment = htmlspecialchars($_REQUEST['payment_mul'], ENT_QUOTES, 'UTF-8');
            $ins_params = htmlspecialchars(trim($_REQUEST['card_type']), ENT_QUOTES, 'UTF-8');            
          
            if($payment_type == 'multi' && $ins_payment == 'ins_payment') {
                $ins_params_arr = explode("##", $ins_params);
                $ipg_args['numberOfInstallments'] = $ins_params_arr['0'];

              
                //$ipg_args['installmentsInterest'] = 'false';
                // for mexico retailer update the interest_installment value 
              
                $interest_mexico = $_REQUEST['installInt'.$ins_params_arr['2']];
 
                if ($country == "mex") {
                    if ($interest_mexico == "yes") {
                        $ipg_args['installmentsInterest'] = 'true';
                        $ipg_args['installmentDelayMonths'] = trim($ins_params_arr['1']);
                    } else {
                        $ipg_args['installmentsInterest'] = 'false';
                        $ipg_args['installmentDelayMonths'] = trim($ins_params_arr['1']);
                    }
                }
            }
        }

        /*
         * Handle Authorization option is enabled and and user provided the card information in checkout
         */
        $pay_type = isset($_REQUEST['pay_type'])? htmlspecialchars($_REQUEST['pay_type']) : '';

        if ($authUX == 'hidden' && $enable == false && $paytype = "newcard") {
			if(isset($_REQUEST['Fiserv_card_type']))
		    {		
			$card_type = htmlspecialchars($_REQUEST['Fiserv_card_type'], ENT_QUOTES, 'UTF-8');
			 $ipg_args['cardFunction']=$card_type;
			}
            $cardNumber = htmlspecialchars($_REQUEST['Fiserv_card_number'], ENT_QUOTES, 'UTF-8');
            $cardExpiryMonth = htmlspecialchars($_REQUEST['Fiserv_expiry_month'], ENT_QUOTES, 'UTF-8');
            $cardExpiryYear = htmlspecialchars($_REQUEST['Fiserv_expiry_year'], ENT_QUOTES, 'UTF-8');
            $payment_type = htmlspecialchars($_REQUEST['payment_type'], ENT_QUOTES, 'UTF-8');

            $expiryCard = $cardExpiryMonth . '/' . $cardExpiryYear;
            $cardExpiry = str_replace(" ", "", $expiryCard);
            $getCardExp = explode("/", $cardExpiry);
            $cardcvc = htmlspecialchars($_REQUEST['Fiserv_cvv'], ENT_QUOTES, 'UTF-8');
            $bname = $address->firstname . ' ' . $address->lastname;
            $ipg_args['cardnumber'] = str_replace(" ", "", $cardNumber);
            $ipg_args['expmonth'] = $cardExpiryMonth;
            $ipg_args['expyear'] = $cardExpiryYear;
            if ($cardExpiry != '' && (strlen($getCardExp[1]) == 2 || strlen($getCardExp[1]) == 4)) {
                if (strlen($getCardExp[1]) == 2)
                    $date = DateTime::createFromFormat('m/y', $cardExpiry);
                if (strlen($getCardExp[1]) == 4)
                    $date = DateTime::createFromFormat('m/Y', $cardExpiry);
                if (isset($date))
                    $ipg_args['expyear'] = $date->format('Y');
            }
            $ipg_args['cvm'] = $cardcvc;
            $ipg_args['bname'] = $bname;
            $ipg_args['full_bypass'] = 'true';
        }
   
    
	     if ($country == "pan" && $reseller == "banco_general")
		{
        ;

            $ipg_args['subtotal'] =  $subtotal - $total_taxes;
			$ipg_args['shipping'] =  $total_shipping;
			$ipg_args['vattax'] =   $total_taxes;
		 }
 
         $ipgform = '';
		 FiservTools::getLogger()->logInfo($ipg_args);
         foreach ($ipg_args as $key => $value) {
            if ($value) {
                $ipgform .= '<input type="hidden" name="' . $key . '" value="' . $value . '" />' . "\n";
            }
        }
        echo '<form action="' . $connectURL . '" method="POST" name="FiservForm" id="FiservForm">
                    ' . $ipgform . '
                    <script type="text/javascript">
                    setTimeout(document.FiservForm.submit(), 1000)
                    </script>
                    <button type="submit" form="FiservForm" value="Submit">Submit</button>

            </form>';
    }

    public function createHash($txndatetime, $chargetotal, $currency, $storeId, $sharedSecret) {
        $stringToHash = $storeId . $txndatetime . $chargetotal . $currency . $sharedSecret;
        $ascii = bin2hex($stringToHash);
        return sha1($ascii);
    }

    public function validpaymentOptions($value) {
        return array_key_exists($value, FiservUtility::paymentOptionsValue()) ? true : false;
    }

}

