<?php

if (!defined('_CAN_LOAD_FILES_'))
    exit;

class AdminOrdersController extends AdminOrdersControllerCore {   


   
    public function postProcess() {      

        if (Tools::isSubmit('partialRefund') || Tools::isSubmit('cancelProduct')) {            
            $id_order = Tools::getValue('id_order');
            $order = new Order($id_order); 
            
            /* Partial refund from order */ 
            if (Tools::isSubmit('partialRefund') && isset($order)) {
                if (Tools::isSubmit('partialRefundProduct') && ($refunds = Tools::getValue('partialRefundProduct')) && is_array($refunds)) {
                    $order_detail_list = array();
                    $full_quantity_list = array();
                    $amount = 0;
                    foreach ($refunds as $id_order_detail => $amount_detail) {
                        $quantity = Tools::getValue('partialRefundProductQuantity');
                        if (!$quantity[$id_order_detail]) {
                            continue;
                        }

                        $full_quantity_list[$id_order_detail] = (int) $quantity[$id_order_detail];

                        $order_detail_list[$id_order_detail] = array(
                            'quantity' => (int) $quantity[$id_order_detail],
                            'id_order_detail' => (int) $id_order_detail
                        );

                        $order_detail = new OrderDetail((int) $id_order_detail);
                        if (empty($amount_detail)) {
                            $order_detail_list[$id_order_detail]['unit_price'] = (!Tools::getValue('TaxMethod') ? $order_detail->unit_price_tax_excl : $order_detail->unit_price_tax_incl);
                            $order_detail_list[$id_order_detail]['amount'] = $order_detail->unit_price_tax_incl * $order_detail_list[$id_order_detail]['quantity'];
                        } else {
                            $order_detail_list[$id_order_detail]['amount'] = (float)str_replace(',', '.', $amount_detail);
                            $order_detail_list[$id_order_detail]['unit_price'] = $order_detail_list[$id_order_detail]['amount'] / $order_detail_list[$id_order_detail]['quantity'];
                        }    
                        $amount += $order_detail_list[$id_order_detail]['amount'];
                    }
                    
                    $shipping_cost_amount = (float)str_replace(',', '.', Tools::getValue('partialRefundShippingCost')) ? (float)str_replace(',', '.', Tools::getValue('partialRefundShippingCost')) : false;
                    
                    if ($amount == 0 && $shipping_cost_amount == 0) {
                        if (!empty($refunds)) {
                            $this->errors[] = Tools::displayError('Please enter a quantity to proceed with your refund.');
                        } else {
                            $this->errors[] = Tools::displayError('Please enter an amount to proceed with your refund.');
                        }                        
                    }else{
                        $choosen = false;
                        $voucher = 0;

                        if ((int)Tools::getValue('refund_voucher_off') == 1) {
                            $amount -= $voucher = (float)Tools::getValue('order_discount_price');
                        } elseif ((int)Tools::getValue('refund_voucher_off') == 2) {
                            $choosen = true;
                            $amount = $voucher = (float)Tools::getValue('refund_voucher_choose');
                        }

                        if ($shipping_cost_amount > 0) {
                            if (!Tools::getValue('TaxMethod')) {
                                $tax = new Tax();
                                $tax->rate = $order->carrier_tax_rate;
                                $tax_calculator = new TaxCalculator(array($tax));
                                $amount += $tax_calculator->addTaxes($shipping_cost_amount);
                            } else {
                                $amount += $shipping_cost_amount;
                            }
                        }
                        
                        Hook::exec('actionOrderPostProcess', array('order' => $order, 'productList' => $order_detail_list, 'qtyList' => $full_quantity_list, 'refundAmount' => $amount), null, false, true, false, $order->id_shop);                        
                    }
                }
            }
            /* Cancel product from order */ 
            elseif (Tools::isSubmit('cancelProduct') && isset($order)) {
                if (!Tools::isSubmit('id_order_detail') && !Tools::isSubmit('id_customization')) {
                    $this->errors[] = Tools::displayError('You must select a product.');                    
                } elseif (!Tools::isSubmit('cancelQuantity') && !Tools::isSubmit('cancelCustomizationQuantity')) {
                    $this->errors[] = Tools::displayError('You must enter a quantity.');                    
                } else {
                    $productList = Tools::getValue('id_order_detail');
                    if ($productList) {
                        $productList = array_map('intval', $productList);
                    }

                    $customizationList = Tools::getValue('id_customization');
                    if ($customizationList) {
                        $customizationList = array_map('intval', $customizationList);
                    }

                    $qtyList = Tools::getValue('cancelQuantity');
                    if ($qtyList) {
                        $qtyList = array_map('intval', $qtyList);
                    }

                    $customizationQtyList = Tools::getValue('cancelCustomizationQuantity');
                    if ($customizationQtyList) {
                        $customizationQtyList = array_map('intval', $customizationQtyList);
                    }

                    $full_product_list = $productList;
                    $full_quantity_list = $qtyList;

                    if ($customizationList) {
                        foreach ($customizationList as $key => $id_order_detail) {
                            $full_product_list[(int) $id_order_detail] = $id_order_detail;
                            if (isset($customizationQtyList[$key])) {
                                $full_quantity_list[(int) $id_order_detail] += $customizationQtyList[$key];
                            }
                        }
                    }  
                    
                    $total = 0;
                    foreach ($productList as $key => $id_order_detail) {
                        $product_list = array();
						
                        $choosen = false;
                        if ((int)Tools::getValue('refund_total_voucher_off') == 1) {
                            $amount -= $voucher = (float)Tools::getValue('order_discount_price');
                        } elseif ((int)Tools::getValue('refund_total_voucher_off') == 2) {
                            $choosen = true;
                            $amount = $voucher = (float)Tools::getValue('refund_total_voucher_choose');
                        }                       
						$order_detail = new OrderDetail((int)$id_order_detail);
					
						$product_list[$id_order_detail] = array(
							'id_order_detail' => $id_order_detail,
							'quantity' => $full_quantity_list[$id_order_detail],
							'unit_price' => $order_detail->unit_price_tax_excl,
							'amount' => isset($amount) ? $amount : $order_detail->unit_price_tax_incl * $full_quantity_list[$id_order_detail],
							
						);
						$total += $product_list[$id_order_detail]['amount'];                        
                    }
                                       
                    if (Tools::isSubmit('shippingBack')) {
                        $total += $order->total_shipping;
                    }

                    Hook::exec('actionOrderPostProcess', array('order' => $order, 'productList' => $full_product_list, 'qtyList' => $full_quantity_list, 'refundAmount' => $total), null, false, true, false, $order->id_shop);                              
                }
            }
        } 
        
        if (!count($this->errors)){            
            parent::postProcess();
        }
    }
}
