/**
 * Card data validation.
 */
function FiservCheckFields() {
    $('#Fiserv_standard input, #Fiserv_standard select').each(function() {
        $(this).removeClass('invalid');
    });

    var cardNumber = $('#Fiserv_card_number').val();
    if(cardNumber.length <= 0 || !(/^\d{13,19}$/.test(cardNumber))){
        $('#Fiserv_card_number').addClass('invalid');
    }

    var cvv = $('#Fiserv_cvv').val();
    if(cvv.length <= 0 || !(/^\d{3,4}$/.test(cvv))) {
        $('#Fiserv_cvv').addClass('invalid');
    }

    var currentTime  = new Date();
    var currentMonth = currentTime.getMonth() + 1;
    var currentYear  = currentTime.getFullYear();

    var expiryYear = $('select[name="Fiserv_expiry_year"] option:selected').val();
    if(expiryYear.length <= 0 || !(/^\d{4,4}$/.test(expiryYear)) || expiryYear < currentYear) {
        $('#Fiserv_expiry_year').addClass('invalid');
    }

    var expiryMonth = $('select[name="Fiserv_expiry_month"] option:selected').val();
    if(expiryMonth.length <= 0 || !(/^\d{1,2}$/.test(expiryMonth)) || (expiryYear == currentYear && expiryMonth < currentMonth)) {
        $('#Fiserv_expiry_month').addClass('invalid');
    }

    return ($('#Fiserv_standard').find('.invalid').length > 0) ? false : true;
}
